package AltiConsole;

import java.awt.BorderLayout;
import java.awt.Color;
//import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
//import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SortOrder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.StandardXYItemRenderer;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;


import org.jdesktop.swingx.JXList;



/**
 * A demo showing the addition and removal of multiple datasets / renderers.
 */
public class AltiConsoleMainScreen extends ApplicationFrame implements ActionListener {

    /** The plot. */
    public XYPlot plot;
   
    /** The index of the last dataset added. */
    private int datasetIndex = 0;
    
  //Menu
  	private JMenuBar jJMenuBar = null;
  	private JMenu fileMenu = null;
  	private JMenu helpMenu = null;
  	private JMenuItem loadDataMenuItem = null;
  	private JMenuItem exitMenuItem = null;
  	private JMenuItem aboutMenuItem = null;
  	
  //List
  	private JXList flightList = null;
  	public JComboBox comPorts;
  	public JComboBox serialRates;
  	private JLabel comPortsLabel;
  	private JLabel serialRatesLabel;
  	public JTextArea txtLog;
  	private JScrollPane scrollPane;
  	private JButton retrieveFlights;
  	private DefaultListModel listData;
  	public AltimeterSerial Serial=null;
  
  	
    /**
     * Constructs main screen of the  application.
     *
     * @param title  the frame title.
     */
    public AltiConsoleMainScreen(final String title) {

        super(title);
        
		//File
        fileMenu = new JMenu();
		fileMenu.setText("File");
		//Load data
		loadDataMenuItem = new JMenuItem();	
		loadDataMenuItem.setText("Retrieve Flight Data");
		loadDataMenuItem.setActionCommand("RETRIEVE_FLIGHT");
		loadDataMenuItem.addActionListener(this);
		
		//Exit
		exitMenuItem = new JMenuItem();	
		exitMenuItem.setText("Exit");
		exitMenuItem.addActionListener(new ActionListener() 
		{
			public void actionPerformed(ActionEvent e) {
						System.exit(0);
					}
		});
		fileMenu.add(loadDataMenuItem);
		fileMenu.add(exitMenuItem);
		
		// Help
		helpMenu = new JMenu("Help");        
		jJMenuBar = new JMenuBar();
		
		//AboutScreen
		aboutMenuItem = new JMenuItem();
		aboutMenuItem.setText("About");
		aboutMenuItem.setActionCommand("ABOUT");
		aboutMenuItem.addActionListener(this);
		
		
		helpMenu.add(aboutMenuItem);
		
		jJMenuBar.add(fileMenu);
		jJMenuBar.add(helpMenu);
		this.setJMenuBar(jJMenuBar);
		
		//Button
		retrieveFlights = new JButton();
		retrieveFlights.setText("Retrieve Flights");
		retrieveFlights.setActionCommand("RETRIEVE_FLIGHT");
		retrieveFlights.addActionListener(this);
		
		//combo serial rate
		String[] serialRateStrings = {
			    	      "300","1200","2400","4800","9600","14400",
			    	      "19200","28800","38400","57600","115200"
			    	    };
			    	    
		serialRatesLabel = new JLabel("COM Port Speed: ");
		serialRates = new JComboBox();
		for (int i = 0; i < serialRateStrings.length; i++)
			    	      serialRates.addItem(serialRateStrings[i] ); 

		comPortsLabel = new JLabel("Port: ");
		comPorts = new JComboBox();
        
		listData = new DefaultListModel();
	   
		flightList = new JXList(listData );
		flightList.addListSelectionListener(new ValueReporter());
		
		JPanel TopPanelLeft = new JPanel();
		TopPanelLeft.setLayout(new BorderLayout());
		TopPanelLeft.add(comPortsLabel, BorderLayout.WEST);
		TopPanelLeft.add(comPorts, BorderLayout.EAST);
		
		JPanel TopPanelMiddle = new JPanel();
		TopPanelMiddle.setLayout(new BorderLayout());
		TopPanelMiddle.add(retrieveFlights, BorderLayout.WEST);
		
		JPanel TopPanelRight = new JPanel();
		TopPanelRight.setLayout(new BorderLayout());
		TopPanelRight.add(serialRatesLabel, BorderLayout.WEST);
		TopPanelRight.add(serialRates, BorderLayout.EAST);
		
		JPanel TopPanel = new JPanel();
		TopPanel.setLayout(new BorderLayout());
		
		TopPanel.add(TopPanelRight, BorderLayout.EAST);
		TopPanel.add(TopPanelMiddle, BorderLayout.CENTER);
		TopPanel.add(TopPanelLeft, BorderLayout.WEST);
		JPanel MiddlePanel = new JPanel();
		MiddlePanel.setLayout(new BorderLayout());
	
		MiddlePanel.add(TopPanel, BorderLayout.NORTH);
		MiddlePanel.add(flightList, BorderLayout.WEST);
		
		
       
        final JFreeChart chart =ChartFactory.createXYLineChart("Altimeter Console", "Time (ms)", "Altitude (meters)", null);
       
        
        chart.setBackgroundPaint(Color.white);
        
        this.plot = chart.getXYPlot();
        this.plot.setBackgroundPaint(Color.lightGray);
        this.plot.setDomainGridlinePaint(Color.white);
        this.plot.setRangeGridlinePaint(Color.white);

        final ValueAxis axis = this.plot.getDomainAxis();
        axis.setAutoRange(true);

        final NumberAxis rangeAxis2 = new NumberAxis("Range Axis 2");
        rangeAxis2.setAutoRangeIncludesZero(false);
       
        final ChartPanel chartPanel = new ChartPanel(chart);

        MiddlePanel.add(chartPanel, BorderLayout.CENTER);
        
        JPanel BottomPanel = new JPanel();
		
		txtLog = new JTextArea(3, 65);
		txtLog.setEditable(false);    

	    scrollPane = new JScrollPane(txtLog);
	    scrollPane.setAutoscrolls(true);
	    BottomPanel.add(scrollPane, BorderLayout.WEST);

	    MiddlePanel.add(BottomPanel, BorderLayout.SOUTH);
        
	 
        setContentPane(MiddlePanel);
        Serial = new AltimeterSerial(this);

        Serial.searchForPorts();
    }

    public void RetrievingFlight()
    {
    	listData=null;

    	listData = new DefaultListModel();
    	if (Serial.getConnected()==true)
    	{
    		System.out.println("I am already connected... let's disconnect\n");
    		Serial.disconnect();
    		Serial.DataReady=false;
    	}

     	 /* Connect */
        Serial.connect();
        if (Serial.getConnected() == true)
        {
            if (Serial.initIOStream() == true)
            {
            	if (Serial.initListener()== true)
            	{
            		Serial.MyFlight = new FlightData();
            		//send command to switch of the continuity test
            		Serial.writeData("f;\n");
            		Serial.writeData("a;\n");
            		
            		long startTime = System.currentTimeMillis();
            		while (!Serial.DataReady )
            		{
            			long currentTime = System.currentTimeMillis();
            			
            			if ((currentTime - startTime) > 10000)
            			{
            				//This is some sort of data retrieval timout 
            				System.out.println("Data retrieval timed out\n");
            				break;
            			}
            		}
            		
            	    List<String> AllFlightNames2;
            	    
            	    AllFlightNames2= Serial.MyFlight.getAllFlightNames2();
            	  
            	    for (String z : AllFlightNames2) {
            	   
            	    	listData.addElement(z);
            	    }
            		
            	    flightList.setModel(listData);
                	flightList.setAutoCreateRowSorter(true);
                	flightList.toggleSortOrder();
             	    flightList.setSortOrder(SortOrder.ASCENDING);
             	   
                	flightList.clearSelection();
                	
                	flightList.setSelectedIndex(0);
                	
                	plot.setDataset(0, Serial.MyFlight.GetFlightData("Flight 1"));   		        	       	    
            	}
            }
        }
    }

    // ****************************************************************************
    
    /**
     * Handles all the actions.
     *
     * @param e  the action event.
     */
    public void actionPerformed(final ActionEvent e) {
       
    	if (e.getActionCommand().equals("ABOUT"))
    	{
    		JOptionPane.showMessageDialog(null,
        			"AltiMulti Datalogger Console\n Copyright Boris du Reau 2012-2013\n" );
    	} 
    	else
    	if (e.getActionCommand().equals("RETRIEVE_FLIGHT"))
    	{
    		System.out.println("retrieving flight\n");
    		
    		RetrievingFlight();
    	}
  
    }

    private class ValueReporter implements ListSelectionListener {
        /** You get three events in many cases -- one for the deselection
         *  of the originally selected entry, one indicating the selection
         *  is moving, and one for the selection of the new entry. In
         *  the first two cases, getValueIsAdjusting returns true,
         *  thus the test below when only the third case is of interest.
         */
        public void valueChanged(ListSelectionEvent event) {
        	System.out.println(flightList.toString());
         if (!event.getValueIsAdjusting()) 
         if (Serial.MyFlight!=null)
         if (flightList!=null)
         if (flightList.isValid())      	 
         {
        	 
        
        	 System.out.println("Selected flight: " +flightList.getSelectedValue().toString());
        	
        	 plot.setDataset(
                     0, Serial.MyFlight.GetFlightData(flightList.getSelectedValue().toString())
                 );
        
         }
        }
      }
    
    

    /**
     * Starting point for the altimeter console application.
     *
     * @param args  ignored.
     */
    public static void main(final String[] args) {

        final AltiConsoleMainScreen alticonsole = new AltiConsoleMainScreen("Altimeter console");
        alticonsole.pack();
        RefineryUtilities.centerFrameOnScreen(alticonsole);
        alticonsole.setVisible(true);

    }

}
